(function(window){
  const _defaults = {
    instructionsPullToRefresh: 'pull to refresh', // text
    instructionsReleaseToRefresh: 'Release to refresh', //text
    instructionsRefreshing: 'refreshing', // text
    threshold: 60, // minimum distance required to trigger the refresh.
    onPull: function(){location.reload()}
  };
  var	_pullLengh = 0;
  var	_startLength = 0;
  var _ptrEle = '';
  var _ptrTextEle = '';
  var _element = '';
  var configOption;
  var pullToRefresh = {
    init: function(cfg){
      configOption = cfg
      Object.keys(_defaults).forEach(function(key){
        cfg[key] = cfg[key] || _defaults[key];
      });
      _element = document.querySelector(cfg.targetElement);
      _ptrEle = document.querySelector(cfg.ptrElement);
      _ptrTextEle = document.querySelector(cfg.ptrTextElement);

      // init style
      _element.style.position = 'relative';
      _ptrEle.style.position = 'absolute';
      _ptrEle.style.visibility = 'hidden'
      _ptrTextEle.innerText = cfg.instructionsPullToRefresh;

      // blind event
      _element.addEventListener('touchstart', function(event) {
        if (_element.scrollTop != 0 || _element.style['transform'] == 'translate(0, 0px)') {
          return
        }
        _ptrEle.style.visibility = 'visible'
        // cfg.setStyle && cfg.setStyle();
        _startLength = event.touches[0].pageY;
        // _element.removeAttribute('style');
        _element.style['transition'] = 'transform 0s';
        // 'pull to refresh'
        _ptrTextEle.innerText = cfg.instructionsPullToRefresh;
      });
      _element.addEventListener('touchmove', function(event) {
        if (_element.scrollTop != 0) {
          return
        }
        _pullLengh = event.touches[0].pageY - _startLength;
        if(_pullLengh > 0){
          pullElement(_element, _pullLengh, cfg);
          event.preventDefault()
        }
      });
      _element.addEventListener('touchend', function() {
        if (_element.scrollTop != 0) {
          return
        }
        if(_pullLengh > cfg.threshold){
          // 'refreshing'
          _ptrTextEle.innerText = cfg.instructionsRefreshing;
          cfg.onPull();
          _pullLengh = 0;
          _element.style['transition'] = 'transform 0.6s ease';
          _element.style['transform'] = 'translate(0, 80px)';
        } else {
          _pullLengh = 0;
          _element.style['transition'] = 'transform 0.6s ease';
          _element.style['transform'] = 'translate(0, -1px)';
        }
      });
    },
    complete:function(){
      var timeout = setTimeout(function() {
        document.querySelector(configOption.ptrElement).style.visibility = 'hidden';
        clearTimeout(timeout);
      }, 600)
      _element = document.querySelector(configOption.targetElement);
      _element.style['transition'] = 'transform 0.6s ease';
      _element.style['transform'] = 'translate(0, -1px)';
    }
  };

  var pullElement = function(element, length, cfg){
    if(length < _ptrEle.offsetHeight){
      element.style['transform'] = 'translate(0, ' + length + 'px)';
      if(length > cfg.threshold){
        // 'release to fresh'
        _ptrTextEle.innerText = cfg.instructionsReleaseToRefresh;
      }
    }
  };
  window.pullToRefresh = pullToRefresh;
})(window);